/** 									// -o-
 * event.pde
 *
 *   public void  keyPressed()  
 *   public void  usage() 
 *   void 	  oscEvent(OscMessage msg)
 *
 * ----------------------------------------------------------------------
 * Copyright © 2011, David Reeder.  All rights reserved.
 * Please see the LICENSE file in this distribution for license details.
 * ----------------------------------------------------------------------
 */
 

// ------------------------------------------- -o--
public void keyPressed()  
{
  /*  XXX -- use this for smoething?
  shiftOn = false; 	// XXX  evaluates at next keypress...

  if ( (CODED == key) && (KeyEvent.VK_SHIFT == keyCode) )  { 
    shiftOn = true;
  }
  */

  switch (key) 
  {
    case 'a': dumpSystemValues(); 				break;

    case 'c': captureVideo = (captureVideo + 1) % 2; 	
              println(printToggle("captureVideo", captureVideo)); 
	      if (1 == captureVideo) { loop(); } else { noLoop(); }
	      							break;

    case 'd': debug = (debug + 1) % 2; 	
              println(printToggle("debug", debug));
	      if (1 == debug) { cursor(); } else { noCursor(); }
	      							break;
    case 'e': experiment(); 					break;

    case 'f': visualFeedback = (visualFeedback + 1) % 2; 	
              println(printToggle("visualFeedback", visualFeedback)); 	
	      							break;
    case 'h': usage(); 						break;

    case 'i': showRawInput = (showRawInput + 1) % 2; 		break;

    case 'M': movieRecord = (movieRecord + 1) % 2; 	
              println( printToggle("movieRecord", movieRecord)
	       	         +", "+ _movieFilename ); 	

      	      if (1 == movieRecord) 
	      {
	        movie = new MovieMaker( this, width, height, 
					  _movieFilename, _movieFPS, 
					  _movieCodec, _movieQuality);
			// XXX  adapt if system values change...
	      } else {
	        movie.finish();
		_movieNumber += 1;
		_movieFilename = _movieDir + _movieName 
				   +"-"+ _sessionTimestamp
				   +"-"+ Integer.toString(_movieNumber) 
				   + _movieSuffix;
	      } 						break;

    case 'n': showDifferance = (showDifferance + 1) % 2; 	
              println(printToggle("showDifferance", showDifferance)); 	
	      							break;
    case 'o': enableOsc = (enableOsc + 1) % 2; 	
              println(printToggle("enableOsc", enableOsc)); 	break;

    case 'r': enableDumpRGB = (enableDumpRGB + 1) % 2; 	
              println(printToggle("enableDumpRGB", enableDumpRGB)); 
	      							break;
    case 'S': displayCapture = (displayCapture + 1) % 2;
    	      if (1 == displayCapture) {
		println( "displayCapture: " + _displayCaptureFilename ); 	
  	      }
			 					break;

    case 't': dumpTriggers(); 					break;

    case 'v': showOverlay = (showOverlay + 1) % 2; 	
              println(printToggle("showOverlay", showOverlay));	break;

    case 'z': cam.settings(); 					break;
  }
} 


// usage()
//
// (nearby keyPressed() to simplify change tracking)
//
public void usage() 
{ 
  println("\nUSAGE--");

  println("  c   capture video (toggle)         " + pts(captureVideo) );
  println("  f   visual feedback (toggle)       " + pts(visualFeedback) );
  println("  i   show raw input video (toggle)  " + pts(showRawInput) );
  println("  n   show differance (toggle)       " + pts(showDifferance) );
  println("  v   show overlay (toggle)          " + pts(showOverlay) );
  println();

  println("  o   OSC (toggle)                   " + pts(enableOsc) );
  println();

  println("  M   begin/end movie (toggle)       " + pts(movieRecord) );
  println("  S   snapshot of current frame 	"); 		
  println();

  println("  a   dump system values             ");
  println("  t   dump triggers 			"); 		
  println();

  println("  d   debug (toggle)                 " + pts(debug) );
  println("  e   run experiment...              ");
  println("  r   enable dumpRGB() -- pixel color difference test"); 
  println("  z   invoke camera settings dialog 	");
  println();

  println("  h   help (this message) 		");
  println();
}



// ------------------------------------------- -o--
void oscEvent(OscMessage msg)
{ 
  println("------- OSC RECV: " + msg.toString() );
}

